#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Place Where Enemy",
	author	= "wS (World-Source.Ru)",
	version = "1.0"
};

#define PLACE_NAME_SIZE					115

new Handle:place_where_enemy_timer;
new Handle:g_PlaceTimer					= INVALID_HANDLE;
new Handle:g_PlaceName_Trie;
new String:g_PlaceName[PLACE_NAME_SIZE];
new g_Enemy;

public OnPluginStart()
{
	place_where_enemy_timer				= CreateConVar("place_where_enemy_timer", "1", "Как часто сообщать о ближайшем противнике", _, true, 0.0);

	g_PlaceName_Trie					= CreateTrie();
	new Handle:t						= g_PlaceName_Trie;
	SetTrieString(t, "BombsiteA",		"Место закладки A");
	SetTrieString(t, "BombsiteB",		"Место закладки B");
	SetTrieString(t, "BombsiteC",		"Место закладки C");
	SetTrieString(t, "Hostages",		"Заложники");
	SetTrieString(t, "HostageRescueZone","Зона спасения заложников");
	SetTrieString(t, "VipRescueZone",	"Зона спасения VIP");
	SetTrieString(t, "CTSpawn",			"База спецназа");
	SetTrieString(t, "TSpawn",			"База террористов");
	SetTrieString(t, "Bridge",			"Мост");
	SetTrieString(t, "Middle",			"Зигзаг");
	SetTrieString(t, "House",			"Дом");
	SetTrieString(t, "Apartment",		"Комната");
	SetTrieString(t, "Apartments",		"Квартира");
	SetTrieString(t, "Market",			"Рынок");
	SetTrieString(t, "Sewers",			"Коллектор");
	SetTrieString(t, "Tunnel",			"Туннель");
	SetTrieString(t, "Ducts",			"Канал");
	SetTrieString(t, "Village",			"Деревня");
	SetTrieString(t, "Roof",			"Крыша");
	SetTrieString(t, "Upstairs",		"Верхний этаж");
	SetTrieString(t, "Downstairs",		"Нижний этаж");
	SetTrieString(t, "Basement",		"Подвал");
	SetTrieString(t, "Crawlspace",		"Погреб");
	SetTrieString(t, "Kitchen",			"Кухня");
	SetTrieString(t, "Inside",			"В помещении");
	SetTrieString(t, "Outside",			"На улице");
	SetTrieString(t, "Tower",			"Башня");
	SetTrieString(t, "WineCellar",		"Винный погреб");
	SetTrieString(t, "Garage",			"Гараж");
	SetTrieString(t, "Courtyard",		"Внутренний двор");
	SetTrieString(t, "Water",			"Вода");
	SetTrieString(t, "FrontDoor",		"Парадная дверь");
	SetTrieString(t, "BackDoor",		"Черный ход");
	SetTrieString(t, "SideDoor",		"Боковая дверь");
	SetTrieString(t, "BackWay",			"Обходной путь");
	SetTrieString(t, "FrontYard",		"Палисадник");
	SetTrieString(t, "BackYard",		"Задний двор");
	SetTrieString(t, "SideYard",		"Боковой двор");
	SetTrieString(t, "Lobby",			"Холл");
	SetTrieString(t, "Vault",			"Подземелье");
	SetTrieString(t, "Elevator",		"Лифт");
	SetTrieString(t, "DoubleDoors",		"Двухстворчатая дверь");
	SetTrieString(t, "SecurityDoors",	"Защитная дверь");
	SetTrieString(t, "LongHall",		"Длинный коридор");
	SetTrieString(t, "SideHall",		"Боковой коридор");
	SetTrieString(t, "FrontHall",		"Центральный коридор");
	SetTrieString(t, "BackHall",		"Дальний коридор");
	SetTrieString(t, "MainHall",		"Основной коридор");
	SetTrieString(t, "FarSide",			"Дальняя сторона");
	SetTrieString(t, "Windows",			"Окна");
	SetTrieString(t, "Window",			"Окно");
	SetTrieString(t, "Attic",			"Мансарда");
	SetTrieString(t, "StorageRoom",		"Складское помещение");
	SetTrieString(t, "ProjectorRoom",	"Проекционное помещение");
	SetTrieString(t, "MeetingRoom",		"Зал заседаний");
	SetTrieString(t, "ConferenceRoom",	"Конференц-зал");
	SetTrieString(t, "ComputerRoom",	"Компьютерный зал");
	SetTrieString(t, "BigOffice",		"Большой офис");
	SetTrieString(t, "LittleOffice",	"Маленький офис");
	SetTrieString(t, "Dumpster",		"Мусорный контейнер");
	SetTrieString(t, "Airplane",		"Самолет");
	SetTrieString(t, "Underground",		"Метро");
	SetTrieString(t, "Bunker",			"Бункер");
	SetTrieString(t, "Mines",			"Мины");
	SetTrieString(t, "Front",			"Спереди");
	SetTrieString(t, "Back",			"Сзади");
	SetTrieString(t, "Rear",			"С тылу");
	SetTrieString(t, "Side",			"Сбоку");
	SetTrieString(t, "Ramp",			"Уклон");
	SetTrieString(t, "Underpass",		"Переход");
	SetTrieString(t, "Overpass",		"Эстакада");
	SetTrieString(t, "Stairs",			"Ступеньки");
	SetTrieString(t, "Ladder",			"Лестница");
	SetTrieString(t, "Gate",			"КПП");
	SetTrieString(t, "GateHouse",		"КПП");
	SetTrieString(t, "LoadingDock",		"Грузовой помост");
	SetTrieString(t, "GuardHouse",		"Караульное помещение");
	SetTrieString(t, "Entrance",		"Вход");
	SetTrieString(t, "VendingMachines",	"Торговые автоматы");
	SetTrieString(t, "Loft",			"Чердак");
	SetTrieString(t, "Balcony",			"Балкон");
	SetTrieString(t, "Alley",			"Аллея");
	SetTrieString(t, "BackAlley",		"Узкий переулок");
	SetTrieString(t, "SideAlley",		"Узкая улица");
	SetTrieString(t, "FrontRoom",		"Гостиная");
	SetTrieString(t, "BackRoom",		"Подсобное помещение");
	SetTrieString(t, "SideRoom",		"Боковая комната");
	SetTrieString(t, "Crates",			"Ящики");
	SetTrieString(t, "Truck",			"Открытая платформа ");
	SetTrieString(t, "Bedroom",			"Спальня");
	SetTrieString(t, "FamilyRoom",		"Общая комната");
	SetTrieString(t, "Bathroom",		"Ванная");
	SetTrieString(t, "LivingRoom",		"Гостиная");
	SetTrieString(t, "Den",				"Рабочий кабинет");
	SetTrieString(t, "Office",			"Офис");
	SetTrieString(t, "Atrium",			"Атриум");
	SetTrieString(t, "Entryway",		"Вход");
	SetTrieString(t, "Foyer",			"Вестибюль");
	SetTrieString(t, "Stairwell",		"Пролет лестницы");
	SetTrieString(t, "Fence",			"Забор");
	SetTrieString(t, "Deck",			"Палуба");
	SetTrieString(t, "Porch",			"Подъезд");
	SetTrieString(t, "Patio",			"Патио");
	SetTrieString(t, "Wall",			"Стена");

	HookEvent("round_freeze_end",		Event_CallBack, EventHookMode_PostNoCopy);
	HookEvent("round_end",				Event_CallBack, EventHookMode_PostNoCopy);
	HookEvent("round_start",			Event_CallBack, EventHookMode_PostNoCopy);
}

public Event_CallBack(Handle:event, const String:name[], bool:silent)
{
	if (g_PlaceTimer != INVALID_HANDLE)
	{
		KillTimer(g_PlaceTimer);
		g_PlaceTimer = INVALID_HANDLE;
	}

	if (name[6] != 'f')
		return;

	new S = GetConVarInt(place_where_enemy_timer);
	if (S > 0) g_PlaceTimer = CreateTimer(float(S), g_PlaceTimer_CallBack, _, TIMER_REPEAT);
}

public Action:g_PlaceTimer_CallBack(Handle:timer)
{
	decl tt_list[MaxClients], ct_list[MaxClients], i;
	new tt_count, ct_count;
	for (i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i) && IsPlayerAlive(i))
		{
			if (GetClientTeam(i) == 2) tt_list[tt_count++] = i;
			else ct_list[ct_count++] = i;
		}
	}
	if (tt_count < 1 || ct_count < 1)
	{
		g_PlaceTimer = INVALID_HANDLE;
		return Plugin_Stop;
	}
	for (i = 0; i < tt_count; i++) wS_ShowMessage(tt_list[i], ct_list, ct_count);
	for (i = 0; i < ct_count; i++) wS_ShowMessage(ct_list[i], tt_list, tt_count);
	return Plugin_Continue;
}

wS_ShowMessage(client, const enemy_list[], enemy_count)
{
	g_Enemy		= 0;
	decl Float:MyPos[3], Float:EnemyPos[3], Float:dist, Float:result_dist, i;
	GetClientAbsOrigin(client, MyPos);
	result_dist	= 0.0;
	for (i = 0; i < enemy_count; i++)
	{
		GetClientAbsOrigin(enemy_list[i], EnemyPos); dist = GetVectorDistance(MyPos, EnemyPos);
		if (result_dist == 0.0 || dist < result_dist)
		{
			result_dist = dist;
			g_Enemy = enemy_list[i];
		}
	}
	if (g_Enemy > 0)
	{
		g_PlaceName[0] = '\0';
		GetEntPropString(g_Enemy, Prop_Send, "m_szLastPlaceName", g_PlaceName, PLACE_NAME_SIZE);
		GetTrieString(g_PlaceName_Trie, g_PlaceName, g_PlaceName, PLACE_NAME_SIZE);
		PrintHintText(client, "Ближайший враг: %N (%.1fм)\n%s", g_Enemy, result_dist/39.3, g_PlaceName);
	}
}